<?php

namespace App\Entity;


use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * Class Pracoviste
 * @package App\Entity
 * @ORM\Entity()
 * @ORM\Table()
 */
class Pracoviste
{

	/**
	 * @var integer
	 * @ORM\Column(type="integer")
	 * @ORM\Id()
	 * @ORM\GeneratedValue()
	 */
	protected $id;

	/**
	 * @var
	 * @ORM\Column(type="string", nullable=true)
	 */
	protected $nazev;

	/**
	 * @var Produkt
	 * @ORM\OneToMany(targetEntity="Produkt", mappedBy="umisteni")
	 *
	 */
	protected $skladoveProdukty;


	/**
	 * @var Pracovnik
	 * @ORM\OneToOne(targetEntity="Pracovnik")
	 * @ORM\JoinColumn(name="manazer_id", referencedColumnName="id", nullable=true)
	 */
	protected $manazer;

	/**
	 * @var PracovniPozice
	 * @ORM\OneToMany(targetEntity="PracovniPozice", mappedBy="kteraPracoviste")
	 */
	protected $pracovniPozicePracoviste;


	/**
	 * @var int
	 * @ORM\Column(type="integer", options={"default":0})
	 */
	protected $pocetProcesu = 0;

	/**
	 * @var Proces
	 * @ORM\ManyToMany(targetEntity="Proces", inversedBy="pridelenaPracoviste")
	 */
	protected $prirazeneProcesy;


	public function __construct()
	{
		$this->pracovniPozicePracoviste = new ArrayCollection();
		$this->prirazeneProcesy = new ArrayCollection();
	}

	/**
	 * @return int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * @return mixed
	 */
	public function getNazev()
	{
		return $this->nazev;
	}

	/**
	 * @param mixed $nazev
	 */
	public function setNazev($nazev)
	{
		$this->nazev = $nazev;
	}

	/**
	 * @return Produkt
	 */
	public function getSkladoveProdukty()
	{
		return $this->skladoveProdukty;
	}

	/**
	 * @return Pracovnik
	 */
	public function getManazer()
	{
		return $this->manazer;
	}

	/**
	 * @param Pracovnik $manazer
	 */
	public function setManazer(Pracovnik $manazer)
	{
		$this->manazer = $manazer;
	}

	/**
	 * @return PracovniPozice
	 */
	public function getPracovniPozicePracoviste()
	{
		return $this->pracovniPozicePracoviste;
	}

	public function clearPracovniPozicePracoviste(){
		$this->pracovniPozicePracoviste->clear();
	}

	/**
	 * @param PracovniPozice $pracovniPozicePracoviste
	 */
	public function addPracovniPozicePracoviste($pracovniPozicePracoviste)
	{
		if(!$this->pracovniPozicePracoviste->contains($pracovniPozicePracoviste)) {
			$this->pracovniPozicePracoviste->add($pracovniPozicePracoviste);
		}
	}

	/**
	 * @return int
	 */
	public function getPocetProcesu()
	{
		return $this->pocetProcesu;
	}

	/**
	 * @param int $pocetProcesu
	 */
	public function setPocetProcesu($pocetProcesu)
	{
		$this->pocetProcesu = $pocetProcesu;
	}

	/**
	 * @return Proces
	 */
	public function getPrirazeneProcesy()
	{
		return $this->prirazeneProcesy;
	}

	public function addPrirazeneProcesy(Proces $proces) {
		if(!$this->prirazeneProcesy->contains($proces)) {
			$this->prirazeneProcesy->add($proces);
		}
	}

}