<?php

namespace App\Entity;


use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * Class Proces
 * @package App\Entity
 * @ORM\Entity()
 * @ORM\Table()
 */
class Proces
{

	/**
	 * @var integer
	 * @ORM\Column(type="integer")
	 * @ORM\Id()
	 * @ORM\GeneratedValue()
	 */
	protected $id;

	/**
	 * @var string
	 * @ORM\Column(type="string")
	 *
	 */
	protected $nazev;

	/**
	 * @var string
	 * @ORM\Column(type="text", nullable=true)
	 */
	protected $popis;

	/**
	 * @var integer
	 * @ORM\Column(type="integer", options={"default": 0})
	 */
	protected $dobaTrvaniVMin = 0;

	/**
	 * @var integer
	 * @ORM\Column(type="integer", options={"default": 0})
	 */
	protected $kapacitaPrirazenychPracovniku = 0;

	/**
	 * @var integer
	 * @ORM\Column(type="integer", options={"default": 0})
	 */
	protected $cenaProcesu;


	/**
	 * @var ArrayCollection
	 * @ORM\ManyToMany(targetEntity="Pracovnik", mappedBy="pridruzeneProcesy", cascade={"all"})
	 */
	protected $prirazeniPracovnici;

	/**
	 * @var Produkt
	 * @ORM\OneToOne(targetEntity="Produkt", mappedBy="prirazenoProcesum")
	 * @ORM\JoinColumn(name="produkt_prirazeneProdukty", referencedColumnName="id", nullable=true)
	 */
	protected $prirazeneProdukty;

	/**
	 * @var ArrayCollection
	 * @ORM\ManyToMany(targetEntity="Pracoviste", mappedBy="prirazeneProcesy")
	 */
	protected  $pridelenaPracoviste;

	public function __construct()
	{
		$this->prirazeniPracovnici = new ArrayCollection();
		$this->pridelenaPracoviste = new ArrayCollection();
	}

	/**
	 * @return int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * @return string
	 */
	public function getNazev()
	{
		return $this->nazev;
	}

	/**
	 * @param string $nazev
	 */
	public function setNazev($nazev)
	{
		$this->nazev = $nazev;
	}

	/**
	 * @return string
	 */
	public function getPopis()
	{
		return $this->popis;
	}

	/**
	 * @param string $popis
	 */
	public function setPopis($popis)
	{
		$this->popis = $popis;
	}

	/**
	 * @return int
	 */
	public function getDobaTrvaniVMin()
	{
		return $this->dobaTrvaniVMin;
	}

	/**
	 * @param int $dobaTrvaniVMin
	 */
	public function setDobaTrvaniVMin($dobaTrvaniVMin)
	{
		$this->dobaTrvaniVMin = $dobaTrvaniVMin;
	}

	/**
	 * @return int
	 */
	public function getKapacitaPrirazenychPracovniku()
	{
		return $this->kapacitaPrirazenychPracovniku;
	}

	/**
	 * @param int $kapacitaPrirazenychPracovniku
	 */
	public function setKapacitaPrirazenychPracovniku($kapacitaPrirazenychPracovniku)
	{
		$this->kapacitaPrirazenychPracovniku = $kapacitaPrirazenychPracovniku;
	}

	/**
	 * @return int
	 */
	public function getCenaProcesu()
	{
		return $this->cenaProcesu;
	}

	/**
	 * @param int $cenaProcesu
	 */
	public function setCenaProcesu($cenaProcesu)
	{
		$this->cenaProcesu = $cenaProcesu;
	}

	/**
	 * @return ArrayCollection
	 */
	public function getPrirazeniPracovnici()
	{
		return $this->prirazeniPracovnici;
	}

	public function clearPrirazeniPracovnici() {
		$this->prirazeniPracovnici->clear();
	}

	/**
	 * @param ArrayCollection $prirazeniPracovnici
	 */
	public function addPrirazeniPracovnici(Pracovnik $prirazeniPracovnici)
	{
		$this->prirazeniPracovnici->add($prirazeniPracovnici);
	}

	/**
	 * @return ArrayCollection
	 */
	public function getPrirazeneProdukty()
	{
		return $this->prirazeneProdukty;
	}


	/**
	 * @param Produkt $prirazeneProdukty
	 */
	public function setPrirazeneProdukty($prirazeneProdukty)
	{
		$this->prirazeneProdukty = $prirazeneProdukty;
	}

	/**
	 * @return ArrayCollection
	 */
	public function getPridelenaPracoviste()
	{
		return $this->pridelenaPracoviste;
	}

	public function clearPridelenaPracoviste() {
		$this->pridelenaPracoviste->clear();
	}

	/**
	 * @param ArrayCollection $pridelenaPracoviste
	 */
	public function addPridelenaPracoviste($pridelenaPracoviste)
	{
		$this->pridelenaPracoviste->add($pridelenaPracoviste);
	}



}