<?php

namespace App\Forms;


use App\Entity\PracovniPozice;
use Doctrine\ORM\EntityManager;

class PracovniPoziceForm
{
	/** @var  FormFactory */
	protected $formFactory;

	/** @var EntityManager */
	protected $em;

	public function __construct(FormFactory $formFactory, EntityManager $em)
	{
		$this->formFactory = $formFactory;
		$this->em = $em;
	}


	public function create(callable $onSuccess) {
		$form = $this->formFactory->create();

		$form->addText('nazevFunkce', 'Název funkce')
			->setRequired();

		$form->addText('hodinovaMzda', 'Hodinová mzda')
			->setRequired()
			->setType('number');

		$form->addSubmit('send', 'Uložit');

		$form->addHidden('id');

		$form->onSuccess[] = function ($form, $values) use($onSuccess){
			if($values->id) {
				$entity = $this->em->getRepository(PracovniPozice::class)->find($values->id);
			}else{
				$entity = new PracovniPozice();
			}

			$entity->setNazevFunkce($values->nazevFunkce);
			$entity->setHodinovaMzda($values->hodinovaMzda);

			$this->em->persist($entity);
			$this->em->flush();

			$onSuccess();
		};

		return $form;
	}

}