<?php

namespace App\Grid;


use Nette\Security\User;
use Ublaboo\DataGrid\DataGrid;
use Ublaboo\DataGrid\Localization\SimpleTranslator;

class GridFactory
{

	/** @var  User */
	protected $user;

	public function __construct(User $user)
	{
		$this->user = $user;
	}

	public function create() {
		$grid = new DataGrid();

		if($this->user->isLoggedIn()) {
			$grid->addAction('edit', 'Upravit');
			$grid->addAction('delete', 'Smazat');
		}

		$translator = new SimpleTranslator([
				'ublaboo_datagrid.no_item_found_reset' => 'Žádné položky nenalezeny. Filtr můžete vynulovat',
				'ublaboo_datagrid.no_item_found' => 'Žádné položky nenalezeny.',
				'ublaboo_datagrid.here' => 'zde',
				'ublaboo_datagrid.items' => 'Položky',
				'ublaboo_datagrid.all' => 'všechny',
				'ublaboo_datagrid.from' => 'z',
				'ublaboo_datagrid.reset_filter' => 'Resetovat filtr',
				'ublaboo_datagrid.group_actions' => 'Hromadné akce',
				'ublaboo_datagrid.show_all_columns' => 'Zobrazit všechny sloupce',
				'ublaboo_datagrid.hide_column' => 'Skrýt sloupec',
				'ublaboo_datagrid.action' => 'Akce',
				'ublaboo_datagrid.previous' => 'Předchozí',
				'ublaboo_datagrid.next' => 'Další',
				'ublaboo_datagrid.choose' => 'Vyberte',
				'ublaboo_datagrid.execute' => 'Provést',
				'ublaboo_datagrid.per_page_submit' => 'Změnit',

				'Name' => 'Jméno',
				'Inserted' => 'Vloženo'
		]);
		$grid->setTranslator($translator);

		return $grid;
	}

}