<?php

namespace App\Grid;


use App\Entity\PracovniPozice;
use Doctrine\ORM\EntityManager;

class PracovniPoziceGrid
{

	/** @var  GridFactory */
	protected $gridFactory;

	protected $repository;

	public function __construct(GridFactory $gridFactory, EntityManager $em)
	{
		$this->gridFactory = $gridFactory;
		$this->repository = $em->getRepository(PracovniPozice::class);
	}

	public function create() {
		$grid = $this->gridFactory->create();

		$grid->setDefaultPerPage(50);

		$grid->setDataSource($this->repository->createQueryBuilder('p'));

		$grid->addColumnText('id', 'ID')
			->setSortable();

		$grid->addColumnText('nazevFunkce', 'Název funkce')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('hodinovaMzda', 'Hodinová mzda')
			->setSortable()
			->setFilterRange();

		return $grid;
	}

}