<?php

namespace App\Grid;


use App\Entity\Pracovnik;
use App\Entity\PracovniPozice;
use Doctrine\ORM\EntityManager;

class PracovnikGrid
{

	/** @var  GridFactory */
	protected $gridFactory;

	protected $repository;

	public function __construct(GridFactory $gridFactory, EntityManager $em)
	{
		$this->gridFactory = $gridFactory;
		$this->repository = $em->getRepository(Pracovnik::class);
	}

	public function create() {
		$grid = $this->gridFactory->create();

		$grid->setDefaultPerPage(30);

		$grid->setDataSource($this->repository->createQueryBuilder('p'));

		$grid->addColumnText('id', 'ID')
			->setSortable();

		$grid->addColumnText('jmeno', 'Jméno')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('prijmeni', 'Příjmení')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('pracovniPozice', 'Pracovní pozice')
			->setRenderer(function($item) {
				//dump($item);exit;
				return $item->getPracovniPozice()->getNazevFunkce();
			})
			->setSortable()
			->setFilterText();

		$grid->addAction('detail', 'Detail');


		$grid->addColumnDateTime('datumNastupu', 'Den nástupu')
			->setSortable()
			->setFilterDate();


		return $grid;
	}

}