<?php

namespace App\Grid;


use App\Entity\Proces;
use Doctrine\ORM\EntityManager;
use Ublaboo\DataGrid\DataGrid;

class ProcesyGrid
{
	/** @var  GridFactory */
	protected $gridFactory;

	/** @var EntityManager  */
	protected $entity;

	public function __construct(GridFactory $gridFactory, EntityManager $em)
	{
		$this->gridFactory = $gridFactory;
		$this->entity = $em->getRepository(Proces::class);

	}

	public function create() {
		$grid = $this->gridFactory->create();

		$grid->setDefaultPerPage(50);

		$grid->setDataSource($this->entity->createQueryBuilder('p'));

		$grid->addColumnText('id', 'ID')
			->setSortable();

		$grid->addColumnText('nazev', 'Název')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('dobaTrvaniVMin', 'Doba trvání (min.)')
			->setSortable()
			->setFilterRange();

		$grid->addColumnText('kapacitaPrirazenychPracovniku', 'Kapacita prac.')
			->setSortable()
			->setFilterRange();

		$grid->addColumnText('cenaProcesu', 'Cena procesu')
			->setSortable()
			->setFilterRange();

		$grid->addAction('detail', 'Detail');


		return $grid;
	}


}