<?php

namespace App\Grid;


use App\Entity\Produkt;
use Kdyby\Doctrine\EntityManager;

class ProduktGrid
{

	/** @var  GridFactory  */
	protected $gridFactory;

	protected $repository;

	public function __construct(GridFactory $gridFactory, EntityManager $em)
	{
		$this->gridFactory = $gridFactory;
		$this->repository = $em->getRepository(Produkt::class);
	}

	public function create() {
		$grid = $this->gridFactory->create();

		$grid->setDefaultPerPage(50);
		$grid->setDataSource($this->repository->createQueryBuilder('p'));

		$grid->addColumnText('id', 'ID')
			->setSortable();

		$grid->addColumnText('nazev', 'Název')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('popis', 'Popis')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('cena', 'Cena')
			->setRenderer(function($item){
				return $item->getCena()." Kč";
			})
			->setSortable()
			->setFilterRange();


		return $grid;
	}

}