<?php

namespace App\Grid;


use App\Entity\User;
use Doctrine\ORM\EntityManager;

class UserGrid
{

	/** @var  GridFactory */
	protected $gridFactory;

	/** @var  User */
	protected $repository;

	public function __construct(GridFactory $gridFactory, EntityManager $em)
	{
		$this->gridFactory = $gridFactory;
		$this->repository = $em->getRepository(User::class);

	}

	public function create() {
		$grid = $this->gridFactory->create();

		$grid->setDefaultPerPage(30);
		$grid->setDataSource($this->repository->createQueryBuilder('u'));

		$grid->addColumnText('id', 'ID')
			->setSortable();

		$grid->addColumnText('username', 'Už.jméno')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('name', 'Jméno')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('email', 'Email')
			->setSortable()
			->setFilterText();

		return $grid;
	}

}