<?php

namespace App\Presenters;


use App\Entity\PracovniPozice;
use App\Forms\PracovniPoziceForm;
use App\Grid\PracovniPoziceGrid;
use Nette\Application\UI\Form;

class PracovniPozicePresenter extends CrudPresenter
{

	/** @var  PracovniPoziceGrid @inject */
	public $grid;

	/** @var  PracovniPoziceForm @inject */
	public $form;

	public function renderAdd() {
		$this->template->title = "Přidat pracovní pozici";
	}

	public function renderEdit($id) {
		$this->template->title = "Upravit pracovní pozici";

		/** @var PracovniPozice $entity */
		$entity = $this->getEntity($id);
		$this['editForm']->setDefaults([
			'id' => $entity->getId(),
			'nazevFunkce' => $entity->getNazevFunkce(),
			'hodinovaMzda' => $entity->getHodinovaMzda(),
		]);
	}

	public function getEntity($id) {
		return $this->em->getRepository(PracovniPozice::class)->find($id);
	}

	public function actionDelete($id) {
		$entity  = $this->getEntity($id);
		$this->em->remove($entity);
		$this->em->flush();

		$this->flashMessage("Pracovní pozice byla smazána");
		$this->redirect('this');
	}
}